%% Opinion Consensus
clear all
close all
clc

N         = 200; % agents
w(1:N)    = (1-2*rand(N,1)); % initial data
w = w(:);      
T  = 10;           % Final time
dt = 0.1;          %  time discretization
ntot = ceil(T/dt); % number of time steps 

C = 0.75;          % Confidence level of the Bounded Confidence model


W    = zeros(N,1); % initialization of vector
P    = zeros(N);   % communication function 
for n = 1:ntot
    
    % communication function
    for i= 1:N
        for j=1:N
            %P(i,j)=1/N;
            P(i,j)  = (abs(w(i)-w(j))<=C)/N; % Bounded confidence interaction
        end
    end
    
    for i= 1:N
            W(i)  = sum(P(i,:)'.*(w-w(i)));
    end
    
    % explicit euler
    w1 = w + dt*W;
    %update
    w  = w1;
 
    % graphics
    scatter(n*ones(length(w),1)*dt,w,20,w);
    xlabel('$t$','interpreter','latex','FontSize',15)
    ylabel('$w$','interpreter','latex','FontSize',15)
    set(gca,'FontSize',16,'LineWidth',1.)
    set(gca,'YTick',[-1:0.5:1],'FontName','Times')
    %set(gca,'XTick',[n*dt*xa],'FontName','Times')
    hold on
    drawnow
    axis([0 ntot*dt+1 -1 1])
    drawnow
end
